
#include <cstdlib> // abs()
#include "lol/math/real.h"

using lol::real;

static real factorial(int x)
{
    real ret = real::R_1;
    int i = 1, multiplier = 1, exponent = 0;

    for (;;)
    {
        if (i++ >= x)
            /* Multiplication is a no-op if multiplier == 1 */
            return ldexp(ret * multiplier, exponent);

        int tmp = i;
        while ((tmp & 1) == 0)
        {
            tmp >>= 1;
            exponent++;
        }
        if (multiplier * tmp / tmp != multiplier)
        {
            ret *= multiplier;
            multiplier = 1;
        }
        multiplier *= tmp;
    }
}

int main(int argc, char **argv)
{
    int n = 130, m = 117, s = 82;

    real p = factorial(n - s);
    real q = factorial(s)
           * factorial((n + abs(m)) / 2 - s)
           * factorial((n - abs(m)) / 2 - s);
    real z = p / q;

    p.print(70);
    q.print(70);
    z.print(70);

    return 0;
}

